#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "gmp.h"
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>

// version 0.2

/* All copyleft
 * compile with: gcc rsa2.c -lgmp -o rsa
 * Lars Hvam Petersen, 2004
 */

mpz_t num;

void catch_int(int sig_num) {
  signal(SIGINT, catch_int);
  printf("Tried: ");
  mpz_out_str (stdout, 10, num);
  printf("\n");
  exit(0);
}

int main (int argc, char **argv) {
  mpz_t n, r, d, rsa_t, zero, one, randint;
  gmp_randstate_t state;
  int class;
  int i;
  int first=0;
  char* rsa="3107418240490043721350750035888567930037346022842727545720161948823206440518081504556346829671723286782437916272838033415471073108501919548529007337724822783525742386454014691736602477652346609";
  char str[10000];
  char* czero= "0";
  char* cone= "1";
  FILE *fp;
  
  signal(SIGINT, catch_int);
  
  mpz_init(r);
  mpz_init(n);
  mpz_init(d);
  mpz_init(rsa_t);
  mpz_init(zero);
  mpz_init(num);
  mpz_set_str(zero, czero, 0);
  mpz_init(one);
  mpz_set_str(one, cone, 0);
  
  printf("Input length: %d\n", strlen(rsa));

  // find rmd max
  for(i=0; i<(strlen(rsa)/2+1); i++) {
    str[i]=(char)57;
  }
  str[(strlen(rsa)/2)+2]=0;
  printf("Random max: %s\n", str);
  mpz_set_str (n, str, 0);

  mpz_set_str (rsa_t, rsa, 0);
  printf("Trying to break: ");
  mpz_out_str (stdout, 10, rsa_t);
  printf("\n");
  
  // init random number generator
  fp = fopen("/dev/random", "r");  
  mpz_init_set_ui(randint, 1);
  for(i = 1; i <= 10; i++) {
   unsigned int e;
   fread(&e, 4, 1, fp);
   mpz_mul_ui(randint, randint, e);
  }
  fclose(fp);
  gmp_randinit_default(state);
  gmp_randseed(state, randint);

  while(1==1) {
    mpz_urandomm(r, state, n);

    if(first==0) {
      printf("First try: ");
      mpz_out_str (stdout, 10, r);
      printf("\n");
      first=1;
    }

    mpz_mod(d,rsa_t,r);
      
    if(mpz_cmp(zero,d) == 0) {
      printf("Match!!: ");
      mpz_out_str (stdout, 10, r);
      printf("\n");
      break;
    }
      
    mpz_add(num, num, one);
  }

  exit(0);
}

